#ifndef __PSMATCH_H
#define __PSMATCH_H

#ifdef	DYNAMIC_LIB
	#define PSMATCH __declspec( dllexport ) 
#else
	#define PSMATCH
#endif


#define	BMF			1
#define	THOMSON		2
#define	MBF			3
#define	TST			4

typedef	unsigned char byte;

class	CImageProc;
class	Curve;
class	Objects;
class	PointX;
class	NetPoint;

/*
*/
class	ProcTemp {
	short	error;
	short	type;

	int	validarea;
	int	Bl_Size;
	int	W;
	int	H;
	double	M_porog;

	short	wall;

	CImageProc *image;
	byte * out;

	Curve	**fc;
	Objects	*lst;
	short	num_fc;

	Objects *obj;
	Curve	*cfc;

	PointX  *rc;
	short	num_rc;

	NetPoint *net;

	void	Free(void);
	short	CreateObjects(void);
	void	CreateObject(short n);
	void	QSort(short left, short right);
	short	SetLinks(void);
	short	Init(void);
	short	CreateRawData(byte * img, int _W, int _H, short type);
	short	LoadTemplate(byte * ptmp);

	short	CreateFPCode(byte * pfpc);
	short	LoadFPCode(byte * pfpc);
	
	public:
	PSMATCH ProcTemp(short _type, short _wall);
	PSMATCH ~ProcTemp();
	
	short	PSMATCH CreateTemplate(byte * img, int _W, int _H, byte * ptmp, short & status);
	short	PSMATCH CreateFPCode(byte * img,  int _W, int _H, byte * pfpc);
	short	PSMATCH Verify(byte * img, int _W, int _H, byte * ptmp);
	short	PSMATCH VerifyFPCode(byte * pfpc, byte * ptmp);
	short	PSMATCH IdentifyInit(byte * img, int _W, int _H);
	short	PSMATCH IdentifyFind(byte * ptmp);

	short	PSMATCH CreateOneImage(byte * img1, int W1, int H1, byte * img2, int W2, int H2, int & dx, int & dy, int & offsetX);

	short	PSMATCH GetLengthTemplate(byte * ptmp);
	void	GetStatusTemplate(void *);
	void	GetStatusVerify(void *);

	short	GetLengthFPCode(unsigned char * pfpc);
	short	PSMATCH GetQualityTemplate(unsigned char * ptmp);

	#ifdef	DEBUG1
	void	ShowCurrent(CClientDC & cdc, int dx, int dy, short pass);
	#endif

	unsigned char PSMATCH * GetOutPointer(void) { return out; }
};

#endif

