﻿using System;
using System.Runtime.InteropServices;


public enum Typeofimages : short
{
    BMF = 1,
    THOMSON = 2,
    MBF = 3,
    TST = 4
}


public class BioUPIC
{
    [DllImport("bioupic.dll")]
    public static extern void InitBioUPI(Typeofimages _type);

    [DllImport("bioupic.dll")]
    //public static extern short CreateTemplate(ref IntPtr img, UInt32 _W, UInt32 _H, ref IntPtr ptmp, ref short status); 
    public static extern short CreateTemplate(byte [] img, int _W, int _H, byte [] ptmp, ref short status); 
    [DllImport("bioupic.dll")]
    public static extern short Verify(byte[] img, int _W, int _H, byte[] ptmp);
    [DllImport("bioupic.dll")]
    public static extern short IdentifyInit(byte[] img, int _W, int _H);
    [DllImport("bioupic.dll")]
    public static extern short IdentifyFind(byte[] ptmp);
    [DllImport("bioupic.dll")]
    public static extern short GetLengthTemplate(byte[] ptmp);

    [DllImport("bioupic.dll")]
    public static extern short CreateFPCode(byte[] img, int _W, int _H, byte[] pfpc);
    [DllImport("bioupic.dll")]
    public static extern short VerifyFPCode(byte[] pfpc, int _W, int _H, byte[] ptmp);
    [DllImport("bioupic.dll")]
    public static extern short GetQualityTemplate(byte [] ptmp);

    [DllImport("bioupic.dll")]
    public static extern byte [] VersionBioUPI();

    public BioUPIC(Typeofimages _type)
    {
        InitBioUPI(_type);
    }

    public  int CS_CreateTemplate(byte [] img, int _W, int _H, byte [] ptmp, ref short status)
    {
        return CreateTemplate(img, _W, _H, ptmp, ref status); 
    }

    public int CS_Verify(byte[] img, int _W, int _H, byte[] ptmp)
    {
    return  Verify(img, _W, _H, ptmp);
    }

    public int CS_IdentifyInit(byte[] img, int _W, int _H)
    {
        return IdentifyInit(img, _W, _H);
    }

    public int CS_IdentifyFind(byte[] ptmp)
    {
        return IdentifyFind(ptmp);
    }

    public int CS_GetLengthTemplate(byte[] ptmp)
    {
        return GetLengthTemplate(ptmp);
    }

    public int CS_GetQualityTemplate(byte[] ptmp)
    {
        return  GetQualityTemplate(ptmp);
    }


}