﻿
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.Threading

Public Class Form1

    Dim iRc As Integer
    Dim img(200000) As Byte

    Dim image1 As Bitmap

    <DllImport("efisc.dll")> Private Shared Function efisOpenDevice( _
        ByVal typescanner As Integer, ByVal addr As String, ByVal port As Integer) As Integer
    End Function

    <DllImport("efisc.dll")> Private Shared Function efisCloseDevice( _
        ByVal handle As Integer) As Integer
    End Function

    <DllImport("efisc.dll")> Private Shared Function efisStartupSensor( _
        ByVal handle As Integer) As Integer
    End Function

    <DllImport("efisc.dll")> Private Shared Function efisIsFingerPresent( _
            ByVal handle As Integer) As Integer
    End Function

    <DllImport("efisc.dll")> Private Shared Function efisGetImage( _
        ByVal handle As Integer, ByVal img() As Byte) As Integer
    End Function

    <DllImport("efisc.dll")> Private Shared Function efisConvertToBmp8( _
        ByVal handle As Integer, ByVal img() As Byte) As Integer
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        iRc = efisOpenDevice(131, TextBox1.Text, TextBox2.Text)
        If iRc >= 0 Then
            Button1.Enabled = False
            Button2.Enabled = True
            Button3.Enabled = True
            MessageBox.Show("Connect")
        Else
            MessageBox.Show("No Connect")
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If iRc >= 0 Then
            efisCloseDevice(iRc)
            Button1.Enabled = True
            Button2.Enabled = False
            Button3.Enabled = False
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If iRc >= 0 Then
            Button3.Enabled = False
            efisStartupSensor(iRc)
            While (1 = 1)
                If efisIsFingerPresent(iRc) = 0 Then

                    iRc = efisGetImage(iRc, img)

                    image1 = New Bitmap(280, 440)

                    Dim x, y As Integer
                    Dim c As Byte
                    Dim pixelColor As Color

                    ' Loop through the images pixels to reset color.
                    For y = 0 To image1.Height - 1
                        For x = 0 To image1.Width - 1
                            c = img(y * 280 + x)
                            pixelColor = Color.FromArgb(c, c, c)

                            image1.SetPixel(x, y, pixelColor)
                        Next
                    Next


                    PictureBox1.Image = image1
                    PictureBox1.Show()

                    Button3.Enabled = True

                    'efisStartupSensor(iRc)

                    Exit While

                End If
            End While
        End If
    End Sub
End Class



